# docker run -d -it -v /path/on/host:/data -e EULA=TRUE -p 25565:25565 --name mc itzg/minecraft-server
apiVersion: apps/v1
kind: Deployment
metadata:
  name: minecraft-server
  namespace: minecraft
  labels:
    app: minecraft-server
spec:
  replicas: 1
  strategy:
    rollingUpdate:
      maxSurge: 1
      maxUnavailable: 1
    type: RollingUpdate
  selector:
    matchLabels:
      app: minecraft-server
  template:
    metadata:
      labels:
        app: minecraft-server
    spec:
      dnsPolicy: None
      dnsConfig: {nameservers: [192.168.1.1,8.8.8.8,8.8.4.4]}      
      volumes:
      - name: minecraft-data
        persistentVolumeClaim:
          claimName: minecraft-data-pvc
      containers:
      - name: minecraft-server
        image: itzg/minecraft-server:latest
        resources:
          limits:
            memory: 7Gi
          requests:
            memory: 5Gi
        env:
          - name: TYPE
            value: 'PAPER'
          - name:  EULA
            value: 'TRUE'
          - name: MODE
            value: 'survival'
          - name: MOTD
            value: 'Minecraft on K3s'
          - name: USE_AIKAR_FLAGS
            value: 'TRUE'
          - name: INIT_MEMORY
            value: '2G'
          - name: MAX_MEMORY
            value: '7G'
        ports:
        - containerPort: 25565
          name: minecraft
        volumeMounts:
          - name: minecraft-data
            mountPath:  /data
        readinessProbe:
          exec:
            command:
            - mcstatus
            - 127.0.0.1
            - ping
          initialDelaySeconds: 900
          periodSeconds: 30
        livenessProbe:
          exec:
            command:
            - mcstatus
            - 127.0.0.1
            - ping
          initialDelaySeconds: 900
          periodSeconds: 30
